# Return to Ritherdon: Light Wave

This is a support project to help test and monitor the Light Meter in
the factory (Ritherdon). It provide about a minutes worth of streamed
light readings from the facory and displays both readings as animated
line graph. When the exhibition is live, the intention is for it to
provide additional information in the gallery space (I.E. Castlefield
Gallery) for the viewers.

For more information about the 'Return to Ritherdon' project, please
you the links below:

- [Light Meter Code](https://git.abbether.net/return-to-ritherdon/light-meter)
- [Light Meter Documentation](https://git.abbether.net/return-to-ritherdon/rtr-docs/src/branch/master/light-meter)
- [Relay Code](https://git.abbether.net/return-to-ritherdon/relay)
- [Relay Documentation](https://git.abbether.net/return-to-ritherdon/rtr-docs/src/branch/master/relay)
- [Midpoint Code](https://git.abbether.net/return-to-ritherdon/midpoint)
- [Midpoint
  Documentation](https://git.abbether.net/return-to-ritherdon/rtr-docs/src/branch/master/midpoint)
  
They will provide a much broader overview of how the various parts and
projects fit together. Because Light Wave is a support project, there
is no distinct connection between this project and the three main ones
(I.E. Light Meter, Relay and Midpoint).

![Screenshot](attachments/screenshot.png)

This program is set-up as a glorified script (all in one file). So,
there is not much to document. Essentially, all the main code resides
in `light-wave.py` which you can read by clicking the link below:

- [light-wave.ph](https://git.abbether.net/return-to-ritherdon/light-wave/src/branch/master/light-wave.py)

## Project Set-up

This assumes you are on a Linux (Debian/Ubuntu based) machine. Because
of project constraints, other environments have not been tested.

```bash
# Clone repo. if you haven't already.
git clone http://git.abbether.net/return-to-ritherdon/light-wave.git
cd light-wave

# Create and activate the virtual environment
python3 -m venv venv
source venv/bin/activate

# Install dependencies (with pip)
pip install -r requirements.txt

# Run the program
python light-wave.py
```

**You might need to add additional packages (via `apt`)**. The most
notable reason why is because Matplotlib needs some extra things to
run. It looks like the list depends on what you've already installed
on your system -- I've only checked Debian. Use the following link for
more information about installing stuff more Matplotlib:

- [Matplotlib Install Notes](https://matplotlib.org/stable/users/installing.html)

There is not much more to say on this one. It is basically a script
gluing the various parts of Matplotlib together. If you would like to
extend this program, you will need to use the Matplotlib link above
and learn more about how that works.
